﻿Option Explicit On
Option Strict On

Imports System
Imports System.Data.OleDb

Module mdlMain

   Sub Main()
      Console.WriteLine("Demo: Daten aus Access-Datenbank (Northwind) auslesen (VB)")
      Console.WriteLine("")

      'Verbindung aus app.config auslesen '
      '(geht so nur mit VB - C# kennt den My-Namespace nicht!):
      Using cn As New OleDbConnection(My.Settings.DB)

         'So müsste es aussehen, wenn die Verbindungszeichenfolge im 
         'Code hinterlegt wäre, ist aber pfui!
         'Using cn As New OleDbConnection(my.Settings.DB _
         '   "Provider=Microsoft.Jet.OLEDB.4.0;" & _
         '   "Data Source=|DataDirectory|\Northwind.mdb")

         Dim cmd As OleDbCommand = Nothing
         Dim dr As OleDbDataReader = Nothing

         Try
            cn.Open()
            cmd = New OleDbCommand("SELECT * FROM Employees", cn)
            dr = cmd.ExecuteReader
            While dr.Read
               Console.WriteLine("{0} | {1}", _
                  dr("LastName").ToString.PadLeft(15), _
                  dr("FirstName").ToString _
                  )
            End While
            'Wichtig - DataReader immer wieder schließen!
            dr.Close()
         Catch jetEx As OleDbException
            Console.WriteLine("SQL-Fehler: " & jetEx.Message)
         Catch ex As Exception
            Console.WriteLine("Allgemeiner Fehler: " & ex.Message)
         Finally
            cn.Close()
         End Try
         cn.Close()
      End Using

      Console.WriteLine("")
      Console.WriteLine("Return drücken ...")
      Console.ReadLine()
   End Sub

End Module


